#include <bits/stdc++.h>
using namespace std;
int id(string s)
{
    if(s=="O")return 0;
    if(s=="A")return 1;
    if(s=="B")return 2;
    if(s=="AB")return 3;
}
int main()
{
    int n;
    cin>>n;
    int ima[4];
    cin>>ima[0]>>ima[1]>>ima[2]>>ima[3];
    int idx[n],treba[n];
    int ans[n][4];
    for(int i=0;i<n;++i)
    {
        string s;int x;
        cin>>s>>x;
        idx[i]=id(s);
        treba[i]=x;
    }
    //0
    for(int i=0;i<n;++i)
    {
        if(idx[i]==0)
        {
            if(treba[i]>ima[0])
            {
                cout<<"nemoguce"<<endl;
                return 0;
            }
            ima[0]-=treba[i];
            ans[i][0]=treba[i];
            ans[i][1]=0;
            ans[i][2]=0;
            ans[i][3]=0;
        }
    }
    //A
    for(int i=0;i<n;++i)
    {
        if(idx[i]==1)
        {
            if(treba[i]>ima[0]+ima[1])
            {
                cout<<"nemoguce"<<endl;
                return 0;
            }
            ans[i][1]=min(treba[i],ima[1]);
            ima[1]-=ans[i][1];
            ans[i][0]=treba[i]-ans[i][1];
            ima[0]-=ans[i][0];
            ans[i][2]=0;
            ans[i][3]=0;
        }
    }
    //B
    for(int i=0;i<n;++i)
    {
        if(idx[i]==2)
        {
            if(treba[i]>ima[0]+ima[2])
            {
                cout<<"nemoguce"<<endl;
                return 0;
            }
            ans[i][2]=min(treba[i],ima[2]);
            ima[2]-=ans[i][2];
            ans[i][0]=treba[i]-ans[i][2];
            ima[0]-=ans[i][0];
            ans[i][1]=0;
            ans[i][3]=0;
        }
    }
    //AB
    for(int i=0;i<n;++i)
    {
        if(idx[i]==3)
        {
            if(treba[i]>ima[0]+ima[1]+ima[2]+ima[3])
            {
                cout<<"nemoguce"<<endl;
                return 0;
            }
            for(int j=0;j<4;++j)
            {
                ans[i][j]=min(ima[j],treba[i]);
                ima[j]-=ans[i][j];
                treba[i]-=ans[i][j];
            }
        }
    }
    cout<<"moguce"<<endl;
    for(int i=0;i<n;++i)
    {
        cout<<ans[i][0]<<' '<<ans[i][1]<<' '<<ans[i][2]<<' '<<ans[i][3]<<endl;
    }
    return 0;
}